#include <iostream.h>
#define TRUE 1
#define FALSE 0
typedef int Boolean;
typedef struct Leader *Lref; // :    .
typedef struct Trailer *Tref; // :    .

//   .
typedef struct Leader 
{ 
  int Key; //  .
  int Count; // .
  Boolean Flag; //    .
  Tref Trail; //   .
  Lref Next; //       .
};

//   .
typedef struct Trailer
{
  Lref Id;
  Tref Next;
};

//   .
typedef Tref TipElement; //    .
typedef struct Zveno *svqz;
typedef struct Zveno
{
  TipElement Element; //   .
  svqz Sled;
};

//     
//  .
typedef Lref TipElement1;
typedef struct Zveno1 *svqz1;
typedef struct Zveno1
{
  TipElement1 Element; //   .
  svqz1 Sled;
};

class Spisok
{
  private:
     Lref Head; //     .
     Lref Tail; //   
                //     .
     void Udalenie_A (svqz *, svqz *, TipElement *);
     void Udalenie_A1 (svqz1 *, svqz1 *, Lref *);
     void Dobavlenie (svqz *, svqz *, TipElement);
     void Dobavlenie1 (svqz1 *, svqz1 *, Lref);
     void SearchGraph (int, Lref *);
  public:
     Spisok() {//   .
                Head = Tail =  new (Leader); }
     Lref GetHead() { return Head; }
     Lref GetTail() { return Tail; }
     void MakeGraph ();
     void PrintGraph ();
     void Ostov_Breadth ();
};

void main ()
{
  Spisok A;
  Lref t; //   
          //   .

  //      .
  A.MakeGraph ();
  A.PrintGraph (); cout<<endl;
  //   ().
  cout<<": ";
  t = A.GetHead();
  while (t!=A.GetTail())
	 { (*t).Flag = TRUE; t = (*t).Next; }
  A.Ostov_Breadth (); cout<<endl;
}

void Spisok::SearchGraph (int w, Lref *h)
//     
//  w  ,      Head.
{
  *h = Head; (*Tail).Key = w;
  while ((**h).Key!=w) *h = (**h).Next;
  if (*h==Tail)
  //        w.
  //     Head.
  { Tail = new (Leader); (**h).Count = 0;
	 (**h).Trail = NULL; (**h).Next = Tail; }
}

void Spisok::MakeGraph ()
//   Head  
//,   .
{
  int x,y;
  Lref p,q; // .
  Tref t,r; // .
  Boolean Res; //  .
  cout<<"   : ";
  cin>>x;
  while (x!=0)
  {
	  cout<<"   : "; cin>>y;
	  //,      (x,y)?
	  SearchGraph (x, &p); SearchGraph (y,&q);
	  r = (*p).Trail; Res = FALSE;
	  while ((r!=NULL)&&(!Res))
		 if ((*r).Id==q) Res = TRUE;
		 else r = (*r).Next;
	  if (!Res) //  ,     .
		{ t = new (Trailer); (*t).Id = q;
		  (*t).Next = (*p).Trail; (*p).Trail = t; (*q).Count++; }
	  cout<<"   : "; cin>>x;
  }
}

void Spisok::PrintGraph ()
//  ,  
//Head    .
{
  Lref p; // .
  Tref q; // .

  p = Head;
  while (p!=Tail)
  {
	  cout<<(*p).Key<<"("; q = (*p).Trail;
	  while (q!=NULL)
		{ cout<<(*(*q).Id).Key; q = (*q).Next; }
	  cout<<")"; p = (*p).Next; cout<<" ";
  }
}

void Spisok::Dobavlenie (svqz *L, svqz *R, TipElement elem)
//  elem  ,   L  R.
{
  svqz K = new (Zveno);

  K->Element = elem; K->Sled = NULL;
  if (*L==NULL)
	 { (*L) = K; (*R) = K; }
  else { (*R)->Sled = K; (*R) = K; }
}

void Spisok::Dobavlenie1 (svqz1 *L, svqz1 *R, Lref elem)
//  elem  ,  L  R.
{
  svqz1 K = new (Zveno1); 

  K->Element = elem; K->Sled = NULL;
  if (*L==NULL)
	 { (*L) = K; (*R) = K; }
  else { (*R)->Sled = K; (*R) = K; }
}

void Spisok::Udalenie_A (svqz *L, svqz *R, TipElement *A)
//   ,   L  R 
//     A.
{
  svqz q;

  if ((*L)!=NULL)
   if ((*L)->Sled!=NULL)
   {
     (*A) = (*L)->Element; q = (*L);
     (*L) = (*L)->Sled; delete q;
   }
   else {
         (*A) = (*L)->Element; delete *L;
         (*L) = (*R) = NULL;
        }
}

void Spisok::Udalenie_A1 (svqz1 *L, svqz1 *R, Lref *A)
//   ,   L  R  
//     A.
{
  svqz1 q;

  if ((*L)!=NULL)
   if ((*L)->Sled!=NULL)
   {
     (*A) = (*L)->Element; q = (*L);
     (*L) = (*L)->Sled; delete q;
   }
   else {
         (*A) = (*L)->Element; delete *L;
         (*L) = (*R) = NULL;
        }
}

void Spisok::Ostov_Breadth ()
// ,   r   (
//),     .
{
  svqz L;    //   .
  svqz R;    //    .
  svqz1 L1;  //     .
  svqz1 R1;  //      .
  Tref s;    // .
  Tref t;    // .
  Tref Tail1;//      L,R;
  Lref v;    // .

  Tail1 = new (Trailer); //  .
  //  p.
  L = R = NULL;
  L1 = R1 = NULL;
  //    .
  Head->Flag = FALSE;
  t = Head->Trail;
  while ( t != NULL )
   {  Dobavlenie (&L,&R,t); t = t->Next; }
  Dobavlenie (&L,&R,Tail1);
  v = Head;
  while ( L!=NULL )
	//   ...
	{
	  Udalenie_A (&L,&R,&t);
          if ( t != Tail1 )
          {
             if (t->Id->Flag)
             {
               cout << "(" << v->Key << "," << t->Id->Key << ") ";
               t->Id->Flag = FALSE;
             }
             s = t->Id->Trail;
             Dobavlenie1 (&L1,&R1,t->Id);
             while  (s != NULL )
             {
               if (s->Id->Flag)
               {
                 Dobavlenie (&L,&R,s);
                 t->Id->Flag = FALSE;
               }
               s = s->Next;
             }
             Dobavlenie (&L,&R,Tail1);
          }
          else  Udalenie_A1 (&L1,&R1,&v);
        }
}
